#pragma once

#include "Betriebssystem.h"

namespace Framework
{
    class Thread;

    class Critical
    {
    private:
        CRITICAL_SECTION cs;
        Thread *owner;
        int lockCount;
        int id;

    public:
        //! Konstructor
        DLLEXPORT Critical();
        //! Destructor
        DLLEXPORT ~Critical();
        //! sperrt das Objekt
        DLLEXPORT void lock();
        //! versucht das Objekt zu sperren
        DLLEXPORT bool tryLock();
        //! entsperrt das Objekt
        DLLEXPORT void unlock();

        //! gibt true zurck, wenn das Objekt gesperrt ist
        DLLEXPORT bool isLocked() const;
        //! gibt einen Zeiger auf den Thread zurck, der das Objekt gesperrt hat
        DLLEXPORT const Thread *zOwner() const;
    };
}